Difference between revisions of "PySide Advanced Examples"

From FreeCAD Documentation
Jump to navigation Jump to search
 
(5 intermediate revisions by 4 users not shown)
Line 1: Line 1:
 
<languages/>
 
<languages/>
 
<translate>
 
<translate>
==Introduction== <!--T:1-->
 
  
 
</translate>
 
</translate>
 
{{TOCright}}
 
{{TOCright}}
 
<translate>
 
<translate>
 +
 +
==Introduction== <!--T:1-->
  
 
<!--T:14-->
 
<!--T:14-->
Line 16: Line 17:
 
* Change, redirect or add connections between all those elements
 
* Change, redirect or add connections between all those elements
  
==Create Reference for the Main Window== <!--T:3-->
+
==Create Reference for the Main Window== <!--T:15-->
 +
 
 +
<!--T:3-->
 
If you want to work on the FreeCAD interface, the very first thing to do is create a reference to the FreeCAD main window:
 
If you want to work on the FreeCAD interface, the very first thing to do is create a reference to the FreeCAD main window:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 26: Line 30:
 
}}
 
}}
 
<translate>
 
<translate>
==Browse the Children of the Main Window== <!--T:4-->
+
 
 +
==Browse the Children of the Main Window== <!--T:16-->
 +
 
 +
<!--T:4-->
 
Then, you can for example browse through all the widgets of the interface:
 
Then, you can for example browse through all the widgets of the interface:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
 
for child in mw.children():
 
for child in mw.children():
   print 'widget name = ', child.objectName(), ', widget type = ', child
+
   print('widget name = ', child.objectName(), ', widget type = ', child)
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:5-->
 
<!--T:5-->
 
The widgets in a Qt interface are usually nested into "container" widgets, so the children of our main window can themselves contain other children. Depending on the widget type, there are a lot of things you can do. Check the API documentation to see what is possible.
 
The widgets in a Qt interface are usually nested into "container" widgets, so the children of our main window can themselves contain other children. Depending on the widget type, there are a lot of things you can do. Check the API documentation to see what is possible.
  
==Add New Widget Manually== <!--T:6-->
+
==Add New Widget Manually== <!--T:17-->
 +
 
 +
<!--T:6-->
 
Adding a new widget, for example a dockWidget (which can be placed in one of FreeCAD's side panels) is easy:
 
Adding a new widget, for example a dockWidget (which can be placed in one of FreeCAD's side panels) is easy:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 45: Line 57:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:7-->
 
<!--T:7-->
 
You could then add stuff directly to your widget:
 
You could then add stuff directly to your widget:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 56: Line 70:
 
}}
 
}}
 
<translate>
 
<translate>
==Add New Widget by Creating UI Object== <!--T:8-->
+
 
But a preferred method is to create a UI object which will do all of the setup of your widget at once. The big advantage is that such an UI object can be [[Dialog creation|created graphically]] with the Qt Designer program. A typical object generated by Qt Designer is like this:
+
==Add New Widget by Creating UI Object== <!--T:18-->
 +
 
 +
<!--T:8-->
 +
But a preferred method is to create a UI object which will do all of the setup of your widget at once. The big advantage is that such an UI object can be [[Dialog_creation|created graphically]] with the Qt Designer program. A typical object generated by Qt Designer is like this:
 +
 
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 74: Line 92:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:9-->
 
<!--T:9-->
 
To use it, you just need to apply it to your freshly created widget like this:
 
To use it, you just need to apply it to your freshly created widget like this:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 86: Line 106:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 +
==Loading the UI from a Qt Designer .ui File== <!--T:19-->
 +
 +
<!--T:20-->
 +
The key to loading a UI file successfully is to use the full path to the file. As an example, the [[Std_AddonMgr|Addon Manager]] does it like this:
 +
 +
</translate>
 +
{{Code|code=
 +
self.dialog = FreeCADGui.PySideUic.loadUi(os.path.join(os.path.dirname(__file__), "AddonManager.ui"))
 +
}}
 +
<translate>
 +
  
 
</translate>
 
</translate>

Latest revision as of 10:31, 14 March 2021

Other languages:
Deutsch • ‎English • ‎français • ‎italiano • ‎polski • ‎русский

Introduction

The purpose of this page is to cover advanced level examples of the PySide GUI manager (there are accompanying pages PySide Beginner Examples and PySide Intermediate Examples).

By using the PySide module from inside FreeCAD, you have full control over its interface. You can for example:

  • Add your own panels, widgets and toolbars
  • Add or hide elements to existing panels
  • Change, redirect or add connections between all those elements

Create Reference for the Main Window

If you want to work on the FreeCAD interface, the very first thing to do is create a reference to the FreeCAD main window:

import sys
from PySide import QtGui ,QtCore 
app = QtGui.qApp
mw = FreeCADGui.getMainWindow()

Browse the Children of the Main Window

Then, you can for example browse through all the widgets of the interface:

for child in mw.children():
   print('widget name = ', child.objectName(), ', widget type = ', child)

The widgets in a Qt interface are usually nested into "container" widgets, so the children of our main window can themselves contain other children. Depending on the widget type, there are a lot of things you can do. Check the API documentation to see what is possible.

Add New Widget Manually

Adding a new widget, for example a dockWidget (which can be placed in one of FreeCAD's side panels) is easy:

myWidget = QtGui.QDockWidget()
mw.addDockWidget(QtCore.Qt.RightDockWidgetArea,myWidget)

You could then add stuff directly to your widget:

myWidget.setObjectName("my Nice New Widget")
myWidget.resize(QtCore.QSize(300,100)) # sets size of the widget
label = QtGui.QLabel("Hello World", myWidget) # creates a label
label.setGeometry(QtCore.QRect(2,50,200,24))  # sets its size
label.setObjectName("myLabel") # sets its name, so it can be found by name

Add New Widget by Creating UI Object

But a preferred method is to create a UI object which will do all of the setup of your widget at once. The big advantage is that such an UI object can be created graphically with the Qt Designer program. A typical object generated by Qt Designer is like this:

class myWidget_Ui(object):
  def setupUi(self, myWidget):
    myWidget.setObjectName("my Nice New Widget")
    myWidget.resize(QtCore.QSize(300,100).expandedTo(myWidget.minimumSizeHint())) # sets size of the widget

    self.label = QtGui.QLabel(myWidget) # creates a label
    self.label.setGeometry(QtCore.QRect(50,50,200,24)) # sets its size
    self.label.setObjectName("label") # sets its name, so it can be found by name

  def retranslateUi(self, draftToolbar): # built-in QT function that manages translations of widgets
    myWidget.setWindowTitle(QtGui.QApplication.translate("myWidget", "My Widget", None, QtGui.QApplication.UnicodeUTF8))
    self.label.setText(QtGui.QApplication.translate("myWidget", "Welcome to my new widget!", None, QtGui.QApplication.UnicodeUTF8))

To use it, you just need to apply it to your freshly created widget like this:

app = QtGui.qApp
FCmw = app.activeWindow()
myNewFreeCADWidget = QtGui.QDockWidget() # create a new dckwidget
myNewFreeCADWidget.ui = myWidget_Ui() # load the Ui script
myNewFreeCADWidget.ui.setupUi(myNewFreeCADWidget) # setup the ui
FCmw.addDockWidget(QtCore.Qt.RightDockWidgetArea,myNewFreeCADWidget) # add the widget to the main window

Loading the UI from a Qt Designer .ui File

The key to loading a UI file successfully is to use the full path to the file. As an example, the Addon Manager does it like this:

self.dialog = FreeCADGui.PySideUic.loadUi(os.path.join(os.path.dirname(__file__), "AddonManager.ui"))